
#ifndef __CGI_CREDENTIALS_H__
#define __CGI_CREDENTIALS_H__

#include <boost/shared_ptr.hpp>
#include <string>

namespace xmlpp
{
	class Element;
}

namespace cgi
{
	class credentials
	{
		public:

			typedef boost::shared_ptr<credentials> ptr;
			typedef enum { super = 1, admin = 2, analyst = 4, student = 8 } user_t; // Used in logical expressions.

			credentials() { }
			credentials(xmlpp::Element *cred);

			std::string client_name() const { return _client_name; }
			unsigned int client_id() const { return _client_id; }
			std::string user_name() const { return _user_name; }
			std::string full_user_name() const { return _full_user_name; }
			unsigned int user_id() const { return _user_id; }
			std::string token() const { return _token; }
			void token(const std::string& token) { _token = token; }
			std::string password() const { return _password; }
			unsigned lang_id() const { return _lang_id; }
			user_t user_type() const { return _user_type; }

			static std::string to_string(user_t t);

		private:
			std::string _client_name;
			unsigned int _client_id;
			std::string _user_name;
			std::string _full_user_name;
			unsigned int _user_id;
			std::string _token;
			std::string _password;
			unsigned _lang_id;
			user_t _user_type;
	};
}

#endif

