
#ifndef __CGI_ENFORCE_H__
#define __CGI_ENFORCE_H__

#include "util/enforcer.h"
#include "runtime_error.h"

namespace cgi
{
	struct cgi_raiser
	{
		static void raise(const std::string& what, const std::string &code, 
				const std::string &cond, const std::string &file, int line)
		{
			throw cgi_runtime_error(what, code, cond, file, line);
		}
	};
}

#define CGI_ENFORCE(exp, code) \
	*util::MakeEnforcer<util::default_predicate, cgi::cgi_raiser>(\
			(exp), (#exp), (code), __FILE__, __LINE__)

#endif

