
#ifndef __RBASE_MAIN_H__
#define __RBASE_MAIN_H__

#include "credentials.h"
#include <boost/shared_ptr.hpp>
#include <boost/tuple/tuple.hpp>
#include <string>

namespace xmlpp
{
	class Document;
}

namespace cgi
{
	/**
	 *
	 */
	class executor
	{
		public:

			/**
			 * @arg auth Whether there is need for proper authentication or not.
			 */
      executor(bool auth = true) : _auth(auth) { }

			/// credentials, request name, return status
			typedef boost::tuple<credentials::ptr, std::string, std::string> return_t;

			/**
			 * Try to authenticate using the credentials given in the \<credentials\> section
			 * and to run the appropriate handler for every request in the XML document.
			 *
			 * The document's \<response\> section is then modified with the status of the
			 * request handling.
			 */
			return_t operator() (xmlpp::Document *doc);

			bool error() const { return _error; }

		private:

			bool _error;
      bool _auth;
	};
}

#endif

