
#ifndef __CGI_RUNTIME_ERROR__
#define __CGI_RUNTIME_ERROR__

#include "util/runtime_error.h"

#include <string>

#define THROW(what, code) throw cgi_runtime_error(what, "", code, __FILE__, __LINE__)

namespace cgi
{
	class cgi_runtime_error : public util::runtime_error
	{
		public:

		cgi_runtime_error(const std::string &what, const std::string &cond,
				const std::string &code, const std::string &file, int line) :
			util::runtime_error(what, cond, code, file, line)
		{ }

		virtual ~cgi_runtime_error() throw() { }

		virtual std::string module() const { return "cgi"; }
	};
}

#endif

